unit Test_jbEdit1;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, {$IFDEF UNICODE}System.Character,{$ENDIF}
  Forms, Dialogs, StdCtrls, Buttons, jbEdit, Mask;

type
  TForm1 = class(TForm)
    eHumanPin: TPubEdit;
    Button1: TButton;
    eRequired: TPubEdit;
    eParsedStr: TPubEdit;
    eLimChars: TPubEdit;
    eCapitChars: TPubEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    eDec2Hex: TPubEdit;
    Label3: TLabel;
    Label7: TLabel;
    eTimes: TPubMaskEdit;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure eHumanPinValidate(Sender: TObject; var Value: String;
      var CanExit: Boolean);
    procedure eHumanPinMask(Sender: TObject; ToDirection: TToDirection;
      Mask: string; var Value: string);
    procedure eDec2HexConvert(Sender: TObject; ToDirection: TToDirection;
      var Value: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Uses jbStr;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.SetFocus;
  close
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  eParsedStr.Enabled := Not CheckBox1.Checked;
end;

procedure TForm1.eHumanPinMask(Sender: TObject; ToDirection: TToDirection;
  Mask: string; var Value: string);
begin
  if Value <> '' then
    case ToDirection of
      eValueToText: Value := Smash('/', Smash('.', Value));
      eTextToValue: Value := Zip('XX.XX.XX/XXXX', Value);
    end;
end;

procedure TForm1.eHumanPinValidate(Sender: TObject; var Value: String;
  var CanExit: Boolean);
Var
  E: Extended;
begin
  CanExit := True;
  If Value = '' Then Exit;
  {test na datum neni zaveden, sorry}
  If Length(Value) = 9 Then Exit;
  If Length(Value) = 10 Then
  Begin
    E:=StrToFloat(Value);
    {lze pocitat jen pro RC po 1.1.1954 a delky 10 zn.}
    E:=E - 11 * Int(E / 11);
    CanExit := E = 0;
  End
end;

procedure TForm1.eDec2HexConvert(Sender: TObject; ToDirection: TToDirection;
  var Value: string);
begin
  if Value <> '' then
    case ToDirection of
      eValueToText:
        //hexadeciml na decimal
        Value := IntToStr(jbStr.Num(Value, 16)); //  HEX -> DEC


      eTextToValue:
        // decimal na hexadecimal
        Value := jbStr.Doc(Str3Long(Value), 16); //  DEC -> HEX


    end;
end;

end.
